#ifndef __ASSEMBLE__
#define __ASSEMBLE__

#ifndef __TRIANG2__
#include <triang2.h>
#endif

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#define SYMMETRIC	1
#define DIAGONAL	2
#define FULL		0

#define BANKIP 1
#define LINIP 2
#define QUADIP 3
#define USERIP 4
#define QUSERIP 5
#define FOLKIP 6

#define NO_OF_LINE_IPS 2

struct integData
  {
    real *integPointX, *integPointY, *integWeight;
	real **lineIPX, **lineIPY, **lineIW;
	real **shape, **shapeX, **shapeY,
		 **shapeXX, **shapeXY, **shapeYY,
		 ***lineVals;
	int noOfIPoints, noOfLineIP, noOfShapeFunc, symP;
  };
typedef struct integData integData;

struct localData
  {
    int classA, equation, variable;
	TR *t;
	real *x, *y, *p11, *p12, *p21, *p22, *q, *g,
	     *beta1, *beta2, **sigma, **xi;
	real f11, f12, f21, f22, area;
  };
typedef struct localData localData;

extern integData *actIntegData, *linIntegData, *quadIntegData, *cubIntegData;
extern localData *actLocalData;

extern int InitAss(), OpenAss(TR*), CloseAss(),
  CompEllOp(real**), CompMass(real**), CompConvTerm(real**),
  CompRs(real*);
extern real **NumAss(TR*), *NumAssR(TR*);
extern real **ExpMatFull(real**,int,int,int);
extern real *ExpVecFull(real*,int,int);
extern void PrintMatFull(char*,real**,int,int);
extern void PrintVecFull(char*,real*,int);
extern integData *NewIData(int,int,void(*)(real,real,int,
  real*,real*,real*,real*,real*,real*),int);
extern void StdShape(real,real,int,real*,real*,real*,real*,
  real*,real*);
extern void StdQShape(real,real,int,real*,real*,real*,real*,
  real*,real*);
extern void StdCShape(real,real,int,real*,real*,real*,real*,
  real*,real*);
extern int GetDomainVal(real,real,int,real*);
extern int GetBoundVal(real,real,int,real*);
#endif
