/*5:*/
#line 198 "commands.web"


#ifndef __COMMANDS__
#define __COMMANDS__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#define MAX_COM 1000
#define MAX_PAR 100

typedef char**Names;
typedef char*CharClass;

struct COMMAND
{
int no;
int noOfPars;
char**pars;
Names names;
char*results;
int verbose;
};
typedef struct COMMAND COMMAND;
typedef int(*CMDPROC)(COMMAND*);
typedef COMMAND command;
typedef int(*cmdProc)(command*);

struct TextElem
{
char*text;
char*pos;
void(*tproc)(char*);
};
typedef struct TextElem TextElem;

struct CMDMODES
{
int ignoreCases;
int maxPars;
char*prompt;
TextElem*textStack;
int maxCmdStack;
int cmdStackP;
int noOfNames;
int maxIndex;
Names names;
int*index;
cmdProc*procs;
char**shortDes;
Names*pars;
CharClass delimClass;
command*cmd;
char escape;
char comment;
int noParBreak;
};
typedef struct CMDMODES CMDMODES;
typedef struct CMDMODES cmdmodes;

extern int InitCommands(char*,char*,char*);
extern int DoCommands(char*,void(*)(char*));
extern int ExecCommand(command*);
extern command*GetNextCommand();
extern void SetCommand(int,cmdProc);
extern int AddCmdPar(char*,char*);
extern void CmdMainLoop();
extern int ReadIntPar(command*,int,int*);
extern int ReadDoublePar(command*,int,double*);

extern int CheckName(char**,Names,int);
extern int ParsCheck(command*,int,int);
extern char*ConvertString(char**,char*,int);
extern int MakeCharClasses();
extern int SetVerbose(int);

extern void SetLibAddresses(int);

extern cmdmodes stdCmdModes;
extern int goon,LineComplete,cmdError;

#define endClass 127
#define commandClass 10
#define parameterClass 5
#define nameClass 5
#define quoteClass 1
#endif

/*:5*/
