#ifndef __KASKGRAPH__
#define __KASKGRAPH__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __COMMANDS__
#include <commands.h>
#endif

#ifndef __TRIANG2__
#include <triang2.h>
#endif

#ifndef __PARAMETER__
#include <c_parameter.h>
#endif

#define MAX_GRAPH 10

struct graphic
{ int id, no, noClear;
  int boundary, level, triangulation, index, temperature, ddd, areas, cut;
  int noOfLevels, percentage, toDraw, automatic, sparseMat, distr, eqnNo;
  int backCol, triCoarseCol, triFineCol, dirichletCol,
      cauchyCol, neumannCol, levelCol;
  real xMin, xMax, yMin, yMax, xSelMin, xSelMax, ySelMin, ySelMax;
  real rotX, rotY, rotZ;
  real cutX1, cutY1, cutX2, cutY2;
  real *levelsAt;
  int *areaCols;
  TRIANGULATION *triang;
  };
typedef struct graphic graphic;

extern void DrawFrame(graphic*), DrawBound(graphic*), DrawTri(graphic*),
  DrawIndex(graphic*), DrawSol(graphic*), DrawTemp(graphic*),
  Draw3D(graphic*), DrawCut(graphic*), DrawAreas(graphic*);
extern int GetRSol();
extern void DrawMatStruct(graphic*,int,int);
extern void DrawDistr(graphic*,int*,int);
extern void SetGraphAddresses(), UpdateKaskGraphs(), CloseGraphic(int);
extern graphic *NewKaskGraph(), *CopyKaskGraph(graphic *graph);

extern graphic **graphStreams;
extern int *areaCols, noOfAreaCols;
extern int autoSolEvent;

#endif
