#ifndef __PROBLEM__
#define __PROBLEM__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __TRIANG2__
#include <triang2.h>
#endif

#define MAX_PROBLEMS_DEFAULT 20
#define MAX_EQN 5

#define F_CONSTANT 1
#define F_VARIABLE 2
#define F_IGNORE 3
#define F_FAILED -1

typedef struct {
  char	*name, **varNames;
  int (*Laplace)(real,real,int,real*,int,int);
  int (*Convection)(real,real,int,real*,int,int);
  int (*Helmholtz)(real,real,int,real*,int,int);
  int (*Source)(real,real,int,real*,int);
  int (*Obstacle)(real, real,int,real*,int);
  int (*Cauchy)(real,real,int,real*,int,int);
  int (*Dirichlet)(real,real,int,real*,int);
  int (*Sol)(real,real,int,real*,int);
  real **(*LocAss)(TR*);
  real *(*LocAssB)(TR*);
} problem;

typedef struct {
  char *name;
  int maxNoOfProblems, symP;
  int noOfEquations,nodeEntries;
} problemType;

extern int InitProblem(char*,int,int,int,int);
extern int SetProblem(char*,char**,
  int(*)(real,real,int,real*,int,int),
  int(*)(real,real,int,real*,int,int),
  int(*)(real,real,int,real*,int,int),
  int(*)(real,real,int,real*,int),
  int(*)(real,real,int,real*,int),
  int(*)(real,real,int,real*,int,int),
  int(*)(real,real,int,real*,int),
  int(*)(real,real,int,real*,int),
  real** (*)(TR*),
  real* (*)(TR*));

extern void SetProblemAddresses();
extern FindProblem(char*);
extern int SetStdProblems(),SetToms();

extern problem *actProblem, *problems;
extern problemType *theProblem;
extern int ProblemChanged;
#endif
