#ifndef __GEO__
#define __GEO__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __TRIANG3__
#include <triang3.h>
#endif

#ifndef __COMMANDS__
#include <commands.h>
#endif

#define MAXSELS_E 3
#define MAXSELS_T 16
#define MAXD 1000


typedef enum {e_lng,e_midx,e_midy} geoSelsE;
typedef enum {
		t_peri,
		t_area,
		t_gravx,
		t_gravy,
		t_in_radius,
		t_altdx,
                t_altdy,
                t_out_radius,
                t_inx,
                t_iny,
                t_outx,
                t_outy,
                t_ang1,
                t_ang2,
                t_ang3,
                t_inoutratio
       	     } geoSelsT;

/*routines*/

extern int CompGeoLocalE(EDG *ed,geoSelsE *sels,real *vals,int lng);
extern int CompGeoLocalT(TR * t,geoSelsT *sels,real *vals,int lng);
extern int CompDistr(geoSelsT *sels1,int noOfSels,real *max,real *min,real *mean,int *distr,int distrLng,int onlyMaxMin);
extern int InfGeoCmd(COMMAND *cmd);

#endif
		
