#ifndef __PROBLEM__
#define __PROBLEM__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __TRIANG3__
#include <triang3.h>
#endif

#define MAX_PROBLEMS_DEFAULT 20
#define MAX_EQN 5

#define F_CONSTANT 1
#define F_VARIABLE 2
#define F_IGNORE 3
#define F_FAILED -1

#define FAT       0
#define MUSCLE    1
#define BONE      2
#define TUMOR     3
#define INTESTINE 4
#define BRAIN     5

typedef struct {
  char	*name, **varNames;
  int (*Laplace)(real,real,real,int,real*,int,int);
  int (*Convection)(real,real,real,int,real*,int,int);
  int (*Helmholtz)(real,real,real,int,real*,int,int);
  int (*Source)(real,real,real,int,real*,int);
  int (*Obstacle)(real, real,real,int,real*,int);
  int (*Cauchy)(real,real,real,int,real*,int,int);
  int (*Dirichlet)(real,real,real,int,real*,int);
  int (*Sol)(real,real,real,int,real*,int);
  real **(*LocAss)(TD*);
  real *(*LocAssB)(TD*);
} problem;

typedef struct {
  char *name;
  int maxNoOfProblems, symP;
  int noOfEquations,nodeEntries;
} problemType;

extern int InitProblem(char*,int,int,int,int);
extern int SetProblem(char*,char**,
  int(*)(real,real,real,int,real*,int,int),
  int(*)(real,real,real,int,real*,int,int),
  int(*)(real,real,real,int,real*,int,int),
  int(*)(real,real,real,int,real*,int),
  int(*)(real,real,real,int,real*,int),
  int(*)(real,real,real,int,real*,int,int),
  int(*)(real,real,real,int,real*,int),
  int(*)(real,real,real,int,real*,int),
  real** (*)(TD*),
  real* (*)(TD*));

extern void SetProblemAddresses();
extern int SetStdProblems(),SetToms();

extern problem *actProblem, *problems;
extern problemType *theProblem;
extern int ProblemChanged;
#endif
