#include <stdio.h>
#include "minigraph.h"

#ifdef MACCOMP
#include <StdArg.h>
#define va_dcl
#else
#include <varargs.h>
#endif

#ifdef MACCOMP
struct DescRec
  {
    char    *DataPtr;
    short    DataSize;
  };
typedef struct DescRec DescRec;
#endif

int zibpl(id, no, ass, xAdr, yAdr, n)
int id, no, ass, n;
void *xAdr, *yAdr;
  {
     return zibpl_(&id, &no, &ass, xAdr, yAdr, &n);
  }
 



int zibpm(id, no, ass, xAdr, yAdr, n)
int id, no, ass, n;
void *xAdr, *yAdr;
  {
     return zibpm_(&id, &no, &ass, xAdr, yAdr, &n);
  }




int zibfl(id, no, ass, xAdr, yAdr, n)
int id, no, ass, n;
void *xAdr, *yAdr;
  {
     return zibfl_(&id, &no, &ass, xAdr, yAdr, &n);
  }





int zibtx(id, no, ass, x, y, text)
int id, no, ass;
double x, y;
char  *text;
  {
    GRAPHIC *graph = firstGraph;
    float f_x, f_y;
    
/*!  */  if (graph == nil)
/*!  */    {
	f_x = (float)x;
	f_y = (float)y;
	return zibtx_(&id, &no, &ass, &f_x, &f_y, text, strlen(text));
      }

    while (graph != nil)
      {
	if (id == (graph->id) || id == -1)
	  if (no == (graph->wdNo) || no == -1)
	    if (graph->prec == SINGLE)
	      {
	        f_x = (float)x;
	        f_y = (float)y;
	        return zibtx_(&id, &no, &ass, &f_x, &f_y, text, strlen(text));
	      }
	    else
              return zibtx_(&id, &no, &ass, &x, &y, text, strlen(text));
	graph = graph->next;
      }

    fprintf(miniErrorFile,"MiniGraphic - zibtx :  no such window  id = %d  no = %d !\n", 
	   id, no);

    return false;  
  }




int zibcol(id, col_no, rVal, gVal, bVal)
int id, col_no, rVal, gVal, bVal;
  {
     return zibcol_(&id, &col_no, &rVal, &gVal, &bVal);
  }



#ifdef MACCOMP
int zibset(id, no, ass, type)
#else
int zibset(id, no, ass, type, va_alist)
#endif
int id, no, ass, type;
  {
    va_list ap;
    char *valAdr;
    int iVal, succ = false;
    float f_rVal;
    double rVal;
    GRAPHIC *graph = firstGraph;
#ifdef MACCOMP
	DescRec descr;

    va_start(ap,type);
#else
    va_start(ap);
#endif

    if ((type >= 1 && type <= 11) || (type >= 32 && type <= 35) 
         || type == 37 || (type >= 39 && type <= 43))
      {
        iVal = va_arg(ap, int);
        return zibset_(&id, &no, &ass, &type, &iVal, 0);
      }

    else if ((type >= 12 && type <= 17) || (type >= 20 && type <= 31))
	   {
#ifdef MACCOMP
	     rVal = va_arg(ap, extended);
#else
	     rVal = va_arg(ap, double);
#endif
	     va_end(ap);
	     while (graph != nil)
      	       {
		 if ((graph->id) == id || id == -1)
	  	   if ((graph->wdNo) == no || no == -1)
	    	     if (graph->prec == DOUBLE)
	               return zibset_(&id, &no, &ass, &type, &rVal, 0);
		     else
		       {
		         f_rVal = (float)rVal;
	    		 return zibset_(&id, &no, &ass, &type, &f_rVal, 0);
		       }
	         graph = graph->next;
	       }
	     fprintf(miniErrorFile,"MiniGraphic - zibset :  no such window  ");
	     fprintf(miniErrorFile,"id = %d  no = %d !\n", id, no);
	     return false;
	   } 
     else if (type == 36 || type == 38)
	    {
	       valAdr = va_arg(ap, char *);
#ifdef MACCOMP
		  descr.DataPtr = valAdr;
		  descr.DataSize = strlen(valAdr);
		  return zibset_(&id, &no, &ass, &type, &descr, 0);
#else
     	  return zibset_(&id, &no, &ass, &type, valAdr, strlen(valAdr));
#endif
	    }
     else  
        fprintf(miniErrorFile,"MiniGraphic - zibset :  unknown type %d !\n", type);

     va_end(ap);

     return true;
  }





int zibreq(id, no, type, valAdr)
int id, no, type;
void *valAdr;
  {
     return zibreq_(&id, &no, &type, valAdr);
  }





int zibclr(id, no, ass)
int id, no, ass;
  {
     return zibclr_(&id, &no, &ass);
  }




int zibwop(idAdr, noAdr)
int *idAdr, *noAdr;
  {
     return zibwop_(idAdr, noAdr);
  }




int zibwcl(id, no, ass)
int id, no, ass;
  {
     return zibwcl_(&id, &no, &ass);
  }




int zibadd(id, no, assid, assno)
int  id, no, assid, assno;
  {
     return zibadd_(&id, &no, &assid, &assno);
  }





int zibsub(id, no, assid, assno)
int  id, no, assid, assno;
  {
     return zibsub_(&id, &no, &assid, &assno);
  }






int zibgin(id, no, geo, x1koordAdr, y1koordAdr, x2koordAdr, y2koordAdr)
int  id, no, geo;
void *x1koordAdr, *y1koordAdr, *x2koordAdr, *y2koordAdr;
  {
     return zibgin_(&id, &no, &geo, x1koordAdr, y1koordAdr, x2koordAdr, 
		    y2koordAdr);
  }





int zibev(id, no, typAdr,  buttonAdr, xkoordAdr, ykoordAdr, chAdr)
int  id, no, *typAdr, *buttonAdr, *chAdr;
void  *xkoordAdr, *ykoordAdr;    
  {
     return zibev_(&id, &no, typAdr,  buttonAdr, xkoordAdr, ykoordAdr, chAdr);
  }





int zibwt(id, no, typAdr,  buttonAdr, xkoordAdr, ykoordAdr, chAdr)
int  id, no, *typAdr, *buttonAdr, *chAdr;
void  *xkoordAdr, *ykoordAdr;    
  {
     return zibwt_(&id, &no, typAdr,  buttonAdr, xkoordAdr, ykoordAdr, chAdr);
  }



int zibstr(id, no, string, length)
int id, no, *length;
char *string;
  {
     return zibstr_(&id, &no, string, length);
  }
