/*5:*/
#line 148 "access.web"

/*6:*/
#line 159 "access.web"


#include <stdlib.h>
#include <stdio.h>

#include <access.h>

/*:6*//*8:*/
#line 177 "access.web"


static int**protoTypes,*accessLngs,*maxUsed;
static char**accessNames,***accessElemNames;
static int maxL= -1;
static void(*Error)(int,char*)= nil;
static int traceP= false;

/*:8*//*9:*/
#line 187 "access.web"


static void StdError(int,char*);
static void PrintAccess(int,char*,int,int,int*,char**);

/*:9*//*10:*/
#line 195 "access.web"


static void StdError(int errCode,char*errMsg)
{
ZIBStdOut(errMsg);
return;
}

/*:10*/
#line 149 "access.web"

/*11:*/
#line 210 "access.web"


int InitAccess(int maxLists,void(*UserError)(int,char*))
{
int k;

Error= (UserError==nil)?&StdError:UserError;
if(maxL>1)
{
Error(ACC_SECOND,"InitAccess: Second call\n");
return false;
}

protoTypes= (int**)ZIBAlloc((unsigned)maxLists*sizeof(int*));
accessLngs= (int*)ZIBAlloc((unsigned)maxLists*sizeof(int));
maxUsed= (int*)ZIBAlloc((unsigned)maxLists*sizeof(int));
accessNames= (char**)ZIBAlloc((unsigned)maxLists*sizeof(char*));
accessElemNames= (char***)ZIBAlloc((unsigned)maxLists*sizeof(char**));
if((protoTypes==nil)||(accessLngs==nil)||(maxUsed==nil)||
(accessNames==nil)||(accessElemNames==nil))
{
Error(ACC_MEMORY,"InitAccess: Not enough memory\n");
return false;
}

for(k= 0;k<maxLists;k++)
{
protoTypes[k]= nil;
accessLngs[k]= -1;
maxUsed[k]= 0;
accessNames[k]= nil;
accessElemNames[k]= nil;
}
maxL= maxLists;
return true;
}

/*:11*//*12:*/
#line 253 "access.web"


int CreateAccessList(int lng,char*name)
{
int i,k;
char*msgName= name?name:"-",s[256];

if(maxL<0)
if(InitAccess(MAX_ACCESS_LIST,StdError)<0)return-1;

if(lng<0)
{
sprintf(s,"CreateAccessList: Length %d for list '%s' negative\n",
lng,msgName);
Error(ACC_LNG_NEG,s);
return-1;
}

for(k= 0;k<maxL;k++)if(accessLngs[k]<0)break;

if(k==maxL)
{
sprintf(s,"CreateAccess: All %d lists in use\n",maxL);
Error(ACC_ALL_LISTS_USED,s);
return-1;
}

accessLngs[k]= lng;
accessNames[k]= name;
protoTypes[k]= (int*)ZIBAlloc((unsigned)lng*sizeof(int));
accessElemNames[k]= (char**)ZIBAlloc((unsigned)lng*sizeof(char*));

if((protoTypes[k]==nil)||(accessElemNames[k]==nil))
{
Error(ACC_MEMORY,"CreateAccess: Not enough memory\n");
return-1;
}
for(i= 0;i<lng;i++)
{protoTypes[k][i]= -1;accessElemNames[k][i]= nil;}

return k;
}

/*:12*//*13:*/
#line 299 "access.web"


void ReturnAccessList(int listId)
{
if((listId<0)||(listId>maxL))return;
if(accessLngs[listId]==0)return;
if(protoTypes[listId]==nil)return;

ZIBFree((char*)protoTypes[listId]);
ZIBFree((char*)accessElemNames[listId]);
protoTypes[listId]= nil;
accessLngs[listId]= -1;
maxUsed[listId]= 0;
accessNames[listId]= nil;

return;
}

/*:13*//*14:*/
#line 325 "access.web"


int GetAccess(int listId,int lng,int alignment,char*elemName)
{
int i,k;
char*msgName,s[256];

if((listId<0)||(listId>maxL))
{
sprintf(s,"GetAccess: bad access list index %d\n",listId);
Error(ACC_BAD_INDEX,s);
return-1;
}

if(protoTypes[listId]==nil)
{
sprintf(s,"GetAccess: list %d not defined\n",listId);
Error(ACC_NO_INDEX,s);
return-1;
}

for(k= 0;k<=accessLngs[listId];k++)
{
if(accessLngs[listId]-k<lng)
{
msgName= accessNames[listId]?accessNames[listId]:"-";
sprintf(s,"GetAccess: no block (%d) in list %d('%s') for '%s' free\n",
lng,listId,msgName,elemName?elemName:"");
Error(ACC_FULL,s);
return-1;
}
if((protoTypes[listId][k]>=0)||((k%alignment)!=0))continue;
for(i= k;i<k+lng;i++)
if(protoTypes[listId][i]>=0)break;
if(i!=k+lng){k= i;continue;}
for(i= k;i<k+lng;i++)protoTypes[listId][i]= k;
accessElemNames[listId][k]= elemName;
if(maxUsed[listId]<k+lng)maxUsed[listId]= k+lng;
if(traceP)
{
sprintf(s,"GetAccess: List[%d] '%s', elem[%d] '%s'\n",
listId,accessNames[listId],
k,accessElemNames[listId][k]);
Error(0,s);
}
return k;
}
return-1;
}


/*:14*//*15:*/
#line 379 "access.web"


void ReturnAccess(int listId,int elemId)
{
int k;
char*msgName,s[256];

if(traceP)
{
sprintf(s,"ReturnAccess: List[%d] '%s', elem[%d] '%s'\n",
listId,accessNames[listId],
elemId,accessElemNames[listId][elemId]);
Error(0,s);
}
if((listId<0)||(listId>maxL))
{
sprintf(s,"ReturnAccess: bad access list index %d\n",listId);
Error(ACC_BAD_INDEX,s);
return;
}

if(protoTypes[listId]==nil)
{
sprintf(s,"ReturnAccess: list %d not defined\n",listId);
Error(ACC_NO_INDEX,s);
return;
}

msgName= accessNames[listId]?accessNames[listId]:"-";
if((accessLngs[listId]<=elemId)||(elemId<0))
{
sprintf(s,"ReturnAccess: %d not element of  list %d('%s')\n",
elemId,listId,msgName);
Error(ACC_NO_FIELD,s);
return;
}

for(k= elemId;k<accessLngs[listId];k++)
if(protoTypes[listId][k]==elemId)
protoTypes[listId][k]= -1;
else break;
accessElemNames[listId][elemId]= nil;

return;
}


/*:15*//*16:*/
#line 433 "access.web"


void InformAccessLists(void(*UserProc)(int,char*,int,int,int*,char**),int listId)
{
int k;

if(listId==-1)
for(k= 0;k<maxL;k++)
{
if(accessLngs[k]<0)continue;
(*UserProc)(k,accessNames[k],accessLngs[k],maxUsed[k],
protoTypes[k],accessElemNames[k]);
}
else
(*UserProc)(listId,accessNames[listId],accessLngs[listId],
maxUsed[listId],protoTypes[listId],
accessElemNames[listId]);
return;
}

/*:16*//*17:*/
#line 455 "access.web"


int AccessTrace(int mode)
{
int saveMode= traceP;
traceP= mode;
return saveMode;
}

/*:17*//*18:*/
#line 468 "access.web"


static int noOfAccesslists;

static void PrintAccess(int k,char*name,int lng,int maxUsed,
int*proto,char**elemNames)
{
int i,start,no= 0;
char s[256];

noOfAccesslists++;
sprintf(s,"%d Bytes for %d:'%s', max. used %d\n",
lng,k,name?name:"-",maxUsed);
ZIBStdOut(s);
for(i= 0;i<lng;i++)
{
if(proto[i]<0)continue;
start= i;
while((proto[i]==start)&&(i<lng))i++;
sprintf(s,"%2d.  %d Bytes at %3d '%s'\n",no,i-start,start,
elemNames[start]?elemNames[start]:"-");
ZIBStdOut(s);
i--;no++;
}
return;
}

/*:18*//*19:*/
#line 500 "access.web"


int InfAccess(command*cmd)
{
int index,saveMode;
char*tp;

if((cmd->noOfPars)==0)
{
noOfAccesslists= 0;
InformAccessLists(PrintAccess,-1);
sprintf(cmd->results,"%d",noOfAccesslists);
return true;
}
tp= (cmd->pars)[1];
index= CheckName(&tp,cmd->names,nameClass);
if(index==-1)
{
sprintf(globBuf,"Graph: '%s' unknown parameter to %s\n",
(cmd->pars)[1],(cmd->pars)[0]);
ZIBStdOut(globBuf);
return false;
}
switch(index)
{
case 0:
saveMode= AccessTrace(true);
sprintf(cmd->results,saveMode?"1":"0");
break;
case 1:
saveMode= AccessTrace(false);
sprintf(cmd->results,saveMode?"1":"0");
break;
}
return true;
}

/*:19*/
#line 150 "access.web"


/*:5*/
