/*1:*/
#line 31 "compadapt.web"


/*24:*/
#line 231 "compadapt.web"


#include <stdio.h>
#include <math.h>

#include "zibutil.h"
#include "access.h"
#include "appevents.h"
#include "commands.h"
#include "triang2.h"
#include "nodes.h"
#include "problem.h"
#include "assemble.h"
#include "compadapt.h"

/*:24*//*25:*/
#line 254 "compadapt.web"


static int maxSelsE= MAXSELS_E,maxSelsT= MAXSELS_T;
static int*valE= nil;
static int*valT= nil;
static char**nameE= nil;
static char**nameT= nil;
static CompE*ProcE= nil;
static CompT*ProcT= nil;
static int*lngE= nil;
static int*lngT= nil;

/*:25*//*26:*/
#line 269 "compadapt.web"


static int globalIndex,*globalDistr;
static real globalMax,globalMin,globalSum,globalDiff;

/*:26*//*27:*/
#line 276 "compadapt.web"


static int EdgLength(EDG*,real*);
static int TrArea(TR*,real*);

static int CompValsE(EDG*);
static int CompValsT(TR*);
static int MaxMinE(EDG*);
static int MaxMinT(TR*);
static int DistrE(EDG*);
static int DistrT(TR*);

/*:27*//*28:*/
#line 292 "compadapt.web"


compSelsE eValLng= -1;
compSelsT tValArea= -1;
compSelsT tConstAss= -1;

/*:28*//*42:*/
#line 656 "compadapt.web"


int accCD= -1;

struct constData{
real a,b,c,e;
};
typedef struct constData constData;

static real*globalP= nil,*globalG= nil;
static real**assA= nil;
static real*assB= nil;
static real**assErrA= nil;
static real*assErrB= nil;
static int firstWarning= true;
static int ConstInteg(TR*t,constData*cd);

/*:42*/
#line 33 "compadapt.web"

/*29:*/
#line 307 "compadapt.web"


int InitAdaptVals(int maxE,int maxT)
{
int k;

if(valE!=nil)return false;
if(maxE>0)maxSelsE= maxE;
if(maxT>0)maxSelsT= maxE;

valE= (int*)ZIBAlloc(maxSelsE*sizeof(int));
valT= (int*)ZIBAlloc(maxSelsT*sizeof(int));
if(valT==nil)
{
ZIBStdOut("InitAdaptVals: not enough memory (valT)\n");
return false;
}
nameE= (char**)ZIBAlloc(maxSelsE*sizeof(char*));
nameT= (char**)ZIBAlloc(maxSelsT*sizeof(char*));
if(nameT==nil)
{
ZIBStdOut("InitAdaptVals: not enough memory (nameT)\n");
return false;
}
ProcE= (CompE*)ZIBAlloc(maxSelsE*sizeof(CompE));
ProcT= (CompT*)ZIBAlloc(maxSelsT*sizeof(CompT));
if(ProcT==nil)
{
ZIBStdOut("InitAdaptVals: not enough memory (ProcT)\n");
return false;
}
lngE= (int*)ZIBAlloc(maxSelsE*sizeof(int));
lngT= (int*)ZIBAlloc(maxSelsT*sizeof(int));
if(lngT==nil)
{
ZIBStdOut("InitAdaptVals: not enough memory (lngT)\n");
return false;
}

for(k= 0;k<maxSelsE;k++)valE[k]= -1;
for(k= 0;k<maxSelsT;k++)valT[k]= -1;

eValLng= NewCompEVal((CompE)EdgLength,sizeof(real),"Length");
tValArea= NewCompTVal((CompT)TrArea,sizeof(real),"Area");

SetEventProc(RefineEdge,POS_AFTER,(EventProc)nil,(EventProc)CompValsE,
"Compute values");
SetEventProc(RefineTriangle,POS_AFTER,(EventProc)nil,(EventProc)CompValsT,
"Compute values");

return true;
}

/*:29*//*30:*/
#line 366 "compadapt.web"


compSelsE NewCompEVal(CompE proc,int lng,char*name)
{
int k;

if(ProcE==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
for(k= 0;k<maxSelsE;k++)
if(ProcE[k]==nil)break;
if(k==maxSelsE)
{
sprintf(globBuf,"NewCompEVal:maxSelsE=%d reached\n",maxSelsE);
ZIBStdOut(globBuf);
return-1;
}
ProcE[k]= proc;
nameE[k]= name;
lngE[k]= lng;

return k;
}

/*:30*//*31:*/
#line 392 "compadapt.web"


compSelsT NewCompTVal(CompT proc,int lng,char*name)
{
int k;

if(ProcT==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
for(k= 0;k<maxSelsT;k++)
if(ProcT[k]==nil)break;
if(k==maxSelsT)
{
sprintf(globBuf,"NewCompTVal:maxSelsT=%d reached\n",maxSelsT);
ZIBStdOut(globBuf);
return-1;
}
ProcT[k]= proc;
nameT[k]= name;
lngT[k]= lng;

return k;
}

/*:31*//*32:*/
#line 420 "compadapt.web"


int CompGlobalE(compSelsE sel)
{
EDG*ed= actTriang->firstEdge;

if(valE==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
if(valE[sel]>=0)return valE[sel];
if((ProcE[sel])==nil)
{
sprintf(globBuf,
"CompGlobalE: no procedure to compute compSelsE=%d\n",
sel);
ZIBStdOut(globBuf);
}
valE[sel]= GetAccess(nodesState->accEdge,lngE[sel],
sizeof(real),nameE[sel]);
if(valE[sel]<0)return-1;
while(ed)
{
ProcE[sel](ed,(ptr)&(RE(ed,valE[sel])));
ed= ed->next;
}

return valE[sel];
}

/*:32*//*33:*/
#line 451 "compadapt.web"


void StopCompE(compSelsE sel)
{
if(valE==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
ReturnAccess(nodesState->accEdge,valE[sel]);
valE[sel]= -1;
return;
}

/*:33*//*34:*/
#line 463 "compadapt.web"


int CheckCompE(compSelsE sel)
{
return valE[sel];
}

/*:34*//*35:*/
#line 473 "compadapt.web"


static int CompValsE(EDG*ed)
{
int k;
EDG*edSon1= ed->firstSon;
EDG*edSon2= edSon1->next;

for(k= 0;k<maxSelsE;k++)
if(valE[k]>=0)
{
ProcE[k](edSon1,(ptr)&(RE(edSon1,valE[k])));
ProcE[k](edSon2,(ptr)&(RE(edSon2,valE[k])));
}

return true;
}

/*:35*//*36:*/
#line 497 "compadapt.web"


int CompGlobalT(compSelsT sel)
{
TR*t= actTriang->firstTriangle;

if(valT==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
if(valT[sel]>=0)return valT[sel];
if((ProcT[sel])==nil)
{
sprintf(globBuf,
"CompGlobalT: no procedure to compute compSelsT=%d\n",
sel);
ZIBStdOut(globBuf);
}
valT[sel]= GetAccess(nodesState->accTriangle,lngT[sel],
sizeof(real),nameT[sel]);
if(valT[sel]<0)return-1;
while(t)
{
ProcT[sel](t,(ptr)&(RT(t,valT[sel])));
t= t->next;
}

return valT[sel];
}

/*:36*//*37:*/
#line 529 "compadapt.web"


void StopCompT(compSelsT sel)
{
if(valT==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
ReturnAccess(nodesState->accTriangle,valT[sel]);
valT[sel]= -1;
return;
}

/*:37*//*38:*/
#line 541 "compadapt.web"


int CheckCompT(compSelsT sel)
{
return valT[sel];
}

/*:38*//*39:*/
#line 551 "compadapt.web"


static int CompValsT(TR*t)
{
int k;
TR*t1,*t2;

for(k= 0;k<maxSelsE;k++)
if(valT[k]>=0)
{
t1= t->firstSon;
t2= t1->next;
ProcT[k](t1,(ptr)&(RT(t1,valT[k])));
ProcT[k](t2,(ptr)&(RT(t2,valT[k])));
if((t->type)==T_RED)
{
t1= t2->next;
t2= t1->next;
ProcT[k](t1,(ptr)&(RT(t1,valT[k])));
ProcT[k](t2,(ptr)&(RT(t2,valT[k])));
}
}

return true;
}

/*:39*//*40:*/
#line 581 "compadapt.web"


static int EdgLength(EDG*ed,real*val)
{
PT*p1,*p2;
EDG*edFather;
int index= (eValLng<0)?-1:valE[eValLng];
real xd,yd;

if(index>=0)
{
edFather= ed->father;
if(edFather!=nil)
{
*val= RE(edFather,index)*0.5;
return true;
}
}
p1= ed->p1;p2= ed->p2;
xd= (p1->x)-(p2->x);yd= (p1->y)-(p2->y);

*val= sqrt(xd*xd+yd*yd);
return true;
}

/*:40*//*41:*/
#line 611 "compadapt.web"


static int TrArea(TR*t,real*val)
{
PT*p1,*p2,*p3;
TR*tFather;
int index= (tValArea<0)?-1:valT[tValArea];
real f11,f12,f21,f22;

if(index>=0)
{
tFather= t->father;
if(tFather!=nil)
{
if(((t->father)->type)==T_RED)
{
*val= RT(tFather,index)*0.25;
return true;
}
}
}
p1= t->p1;p2= t->p2;p3= t->p3;
f11= (p2->x)-(p1->x);f12= (p3->x)-(p1->x);
f21= (p2->y)-(p1->y);f22= (p3->y)-(p1->y);

*val= (f11*f22-f12*f21)*0.5;
return true;
}

/*:41*//*43:*/
#line 676 "compadapt.web"


int InitConstAss(real*p,real*g)
{
if(tConstAss>=0)return true;
globalP= p;
globalG= g;
if(valT==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
if(assA==nil)assA= ExpMatFull(nil,-1,6,FULL);
if(assA==nil)return false;
if(assB==nil)assB= ExpVecFull(nil,-1,6);
if(assB==nil)return false;
if(assErrA==nil)assErrA= ExpMatFull(nil,-1,6,FULL);
if(assErrA==nil)return false;
if(assErrB==nil)assErrB= ExpVecFull(nil,-1,6);
if(assErrB==nil)return false;
tConstAss= NewCompTVal((CompT)ConstInteg,sizeof(constData),"simplified problem");
if(tConstAss<0)return false;

return true;
}

/*:43*//*44:*/
#line 701 "compadapt.web"


static int ConstInteg(TR*t,constData*cd)
{
PT*p1= t->p1,*p2= t->p2,*p3= t->p3;
real f11,f12,f21,f22,area;
real pFac,gFac,fVals[4];
int rc;

rc= (actProblem->Laplace)((t->p1)->x,(t->p1)->y,t->classA,fVals,0,0);
if((rc!=F_CONSTANT)&&firstWarning)
{
ZIBStdOut("ConstInteg: Laplace returns not F_CONSTANT\n");
firstWarning= false;
}
pFac= fVals[0];
rc= (actProblem->Source)((t->p1)->x,(t->p1)->y,t->classA,fVals,0);
if((rc!=F_CONSTANT)&&firstWarning)
{
ZIBStdOut("ConstInteg: Source returns not F_CONSTANT\n");
firstWarning= false;
}
gFac= fVals[0];
f11= (p2->x)-(p1->x);
f12= (p3->x)-(p1->x);
f21= (p2->y)-(p1->y);
f22= (p3->y)-(p1->y);
area= f11*f22-f12*f21;
pFac= 0.5*pFac/area;
cd->a= (f12*f12+f22*f22)*pFac;
cd->b= (-f12*f11-f22*f21)*pFac;
cd->c= (f11*f11+f21*f21)*pFac;
cd->e= area*gFac/6.0;

return true;
}

/*:44*//*45:*/
#line 741 "compadapt.web"


real**ConstAss(TR*t)
{
constData*cd;
real a,b,c,ab,bc;

if(accCD<0)
accCD= CompGlobalT(tConstAss);
if(accCD<0)return nil;
cd= (constData*)&(t->vec[accCD]);
a= cd->a;b= cd->b;c= cd->c;
ab= a+b;bc= b+c;

assA[0][0]= ab+bc;
assA[1][0]= assA[0][1]= -ab;
assA[1][1]= a;
assA[2][0]= assA[0][2]= -bc;
assA[2][1]= assA[1][2]= b;
assA[2][2]= c;

return assA;
}

real*ConstAssR(TR*t)
{
constData*cd;

if(accCD<0)
accCD= CompGlobalT(tConstAss);
if(accCD<0)return nil;
cd= (constData*)&(t->vec[accCD]);

assB[0]= assB[1]= assB[2]= cd->e;

return assB;
}

/*:45*//*46:*/
#line 782 "compadapt.web"


real**ConstErrAss(TR*t)
{
constData*cd;
real a,b,c,ab,bc;

if(accCD<0)
accCD= CompGlobalT(tConstAss);
if(accCD<0)return nil;
cd= (constData*)&(t->vec[accCD]);
a= (cd->a)*1.333333333333;b= (cd->b)*1.333333333333;c= (cd->c)*1.333333333333;
ab= a+b;bc= b+c;

assErrA[3][0]= -ab-bc;
assErrA[4][0]= assErrA[3][1]= ab;assErrA[5][0]= assErrA[3][2]= bc;
assErrA[4][1]= -a;assErrA[5][1]= assErrA[4][2]= -b;
assErrA[5][2]= -c;

assErrA[3][3]= assErrA[4][4]= assErrA[5][5]= ((cd->a)+(cd->b)+(cd->c))*2.666666666666;

return assErrA;
}

real*ConstErrAssR(TR*t)
{
constData*cd;

if(accCD<0)
accCD= CompGlobalT(tConstAss);
if(accCD<0)return nil;
cd= (constData*)&(t->vec[accCD]);

assErrB[3]= assErrB[4]= assErrB[5]= cd->e;

return assErrB;
}

/*:46*//*47:*/
#line 826 "compadapt.web"


int CompDistrE(compSelsE sel,real*max,real*min,real*mean,
int*distr,int distrLng,int onlyMaxMin)
{
int k,newComp= false;

if(valE==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
if(valE[sel]<0)newComp= true;
if(CompGlobalE(sel)<0)return false;
globalIndex= valE[sel];
globalMax= RMIN;
globalMin= RMAX;
globalSum= ZERO;
ApplyE(MaxMinE,all);
*max= globalMax;
*min= globalMin;
*mean= globalSum/(actTriang->noOfEdges);
if(!onlyMaxMin)
{
if(globalMax<=globalMin)
{
distr[0]= actTriang->noOfEdges;
}
else
{
for(k= 0;k<distrLng;k++)distr[k]= 0;
globalDistr= distr;
globalDiff= ((real)distrLng)/(globalMax-globalMin);
ApplyE(DistrE,all);
}
}

if(newComp)StopCompE(sel);

return true;
}

/*:47*//*48:*/
#line 866 "compadapt.web"


static int MaxMinE(EDG*ed)
{
real val= RE(ed,globalIndex);

if(val<globalMin)globalMin= val;
if(val>globalMax)globalMax= val;
globalSum+= val;

return true;
}

/*:48*//*49:*/
#line 882 "compadapt.web"


static int DistrE(EDG*ed)
{
real val= RE(ed,globalIndex);
int field= (int)(val-globalMin)*globalDiff;

globalDistr[field]++;

return true;
}

/*:49*//*50:*/
#line 896 "compadapt.web"


int CompDistrT(compSelsT sel,real*max,real*min,real*mean,
int*distr,int distrLng,int onlyMaxMin)
{
int k,newComp= false;

if(valT==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
if(valT[sel]<0)newComp= true;
if(CompGlobalT(sel)<0)return false;
globalIndex= valT[sel];
globalMax= RMIN;
globalMin= RMAX;
globalSum= ZERO;
ApplyT(MaxMinT,all);
*max= globalMax;
*min= globalMin;
*mean= globalSum/(actTriang->noOfTriangles);
if(!onlyMaxMin)
{
if(globalMax<=globalMin)
{
distr[0]= actTriang->noOfTriangles;
}
else
{
for(k= 0;k<distrLng;k++)distr[k]= 0;
globalDistr= distr;
globalDiff= ((real)distrLng)/(globalMax-globalMin);
ApplyT(DistrT,all);
}
}

if(newComp)StopCompT(sel);

return true;
}

/*:50*//*51:*/
#line 936 "compadapt.web"


static int MaxMinT(TR*t)
{
real val= RT(t,globalIndex);

if(val<globalMin)globalMin= val;
if(val>globalMax)globalMax= val;
globalSum+= val;

return true;
}

/*:51*//*52:*/
#line 952 "compadapt.web"


static int DistrT(TR*t)
{
real val= RT(t,globalIndex);
int field= (int)(val-globalMin)*globalDiff;

globalDistr[field]++;

return true;
}

/*:52*//*53:*/
#line 970 "compadapt.web"


int InfCompAdaptCmd(command*cmd)
{
int k;

if(actTriang==nil)
{
sprintf(globBuf,"%s: No triangulation\n",(cmd->pars)[0]);
ZIBStdOut(globBuf);
return false;
}
if(ProcE==nil)InitAdaptVals(MAXSELS_E,MAXSELS_T);
ZIBStdOut("Adaptive computations on edges\n");
ZIBStdOut("      name     lng access\n");
for(k= 0;k<maxSelsE;k++)
{
if(ProcE[k]==nil)break;
sprintf(globBuf,"% 4d %15.15s % 3d % 6d\n",k,nameE[k],lngE[k],valE[k]);
ZIBStdOut(globBuf);
}
ZIBStdOut("Adaptive computations on triangles\n");
ZIBStdOut("      name     lng access\n");
for(k= 0;k<maxSelsT;k++)
{
if(ProcT[k]==nil)break;
sprintf(globBuf,"% 4d %15.15s % 3d % 6d\n",k,nameT[k],lngT[k],valT[k]);
ZIBStdOut(globBuf);
}
return true;
}

/*:53*//*54:*/
#line 1004 "compadapt.web"


int InfGeoCmd(command*cmd)
{
real max,min,mean;
int distr[10];

if(actTriang==nil)
{
sprintf(globBuf,"%s: No triangulation\n",(cmd->pars)[0]);
ZIBStdOut(globBuf);
return false;
}
if(tValArea<0)InitAdaptVals(MAXSELS_E,MAXSELS_T);
CompDistrT(tValArea,&max,&min,&mean,distr,10,false);
sprintf(globBuf,"Areas: min=%e, max=%e, mean=%e\n",min,max,mean);
ZIBStdOut(globBuf);

return true;
}

/*:54*/
#line 34 "compadapt.web"


/*:1*/
