/*5:*/
#line 136 "fixedsize.web"

/*6:*/
#line 149 "fixedsize.web"


#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "fixedsize.h"

/*:6*//*7:*/
#line 170 "fixedsize.web"


static ptr**freeLists,**listBuckets;
static int*listLngs,*bucketLngs,*smallLists;
static char**listNames;
static int maxL= -1,listOfLists,checkMode= false;
static void(*Error)(int,char*)= nil;

/*:7*//*8:*/
#line 180 "fixedsize.web"


static ptr GetBucket(int lng,int bucketSize);
static void StdError(int,char*);
static void PrintListLine(int,int,int,int,int,char*);
static int CompString(char*,char*);

/*:8*//*9:*/
#line 190 "fixedsize.web"


static void StdError(int errCode,char*errMsg)
{
ZIBStdOut(errMsg);
return;
}

/*:9*/
#line 137 "fixedsize.web"

/*10:*/
#line 206 "fixedsize.web"


int InitFixedLists(int maxLists,void(*UserError)(int,char*))
{
int k;
Error= (UserError==(void(*)(int,char*))nil)?&StdError:UserError;
if(maxL>1)
{
Error(EFS_SECOND,"InitFixedLists: Second call\n");
return false;
}
if(maxLists<2)
{
Error(EFS_TOO_SHORT,"InitFixedLists: At least 2 lists are needed\n");
return false;
}
/*11:*/
#line 229 "fixedsize.web"


freeLists= (ptr**)ZIBAlloc((long)maxLists*sizeof(ptr*));
listBuckets= (ptr**)ZIBAlloc((long)maxLists*sizeof(ptr*));
listLngs= (int*)ZIBAlloc((long)maxLists*sizeof(int));
smallLists= (int*)ZIBAlloc((long)(MAX_SMALL_SIZE+1)*sizeof(int));
bucketLngs= (int*)ZIBAlloc((long)maxLists*sizeof(int));
listNames= (char**)ZIBAlloc((long)maxLists*sizeof(char*));
if(listNames==nil)return false;

maxL= maxLists;
for(k= 0;k<maxL;k++)
{
freeLists[k]= nil;
listBuckets[k]= nil;
listLngs[k]= -1;
bucketLngs[k]= 0;
listNames[k]= 0;
}

/*:11*/
#line 222 "fixedsize.web"

listOfLists= CreateList(2*sizeof(ptr),200,"list-list");
return listOfLists!=BAD_FIXED_LISTS_ID;
}

/*:10*//*12:*/
#line 259 "fixedsize.web"


int CreateList(int lng,int bucketSize,char*name)
{
int k;
char*msgName= name?name:"-",sbuf[255];

if(maxL<0)
if(InitFixedLists(MAX_FIXED_LISTS,&StdError)<0)return BAD_FIXED_LISTS_ID;

if(bucketSize<1)
{
sprintf(sbuf,"CreateList: Bucket size %d for list '%s' not allowed\n",
bucketSize,msgName);
Error(EFS_BUCKETSIZE,sbuf);
return BAD_FIXED_LISTS_ID;
}

if(!((lng==0)||(lng>=sizeof(ptr))))
{
sprintf(sbuf,"CreateList: Length %d for list '%s' not allowed\n",
lng,msgName);
Error(EFS_LENGTH,sbuf);
return BAD_FIXED_LISTS_ID;
}

for(k= 0;k<maxL;k++)if(listLngs[k]<0)break;

if(k==maxL)
{
sprintf(sbuf,"CreateList: All %d lists in use\n",maxL);
Error(EFS_TOO_MANY,sbuf);
return BAD_FIXED_LISTS_ID;
}



if((lng%8)!=0)lng+= 8-(lng%8);

listLngs[k]= lng;
bucketLngs[k]= bucketSize;
listNames[k]= name;

return k;
}

/*:12*//*13:*/
#line 309 "fixedsize.web"


void ReturnList(int no)
{
ptr*buckets,*saveBucket;

if((no<0)||(no>maxL))return;
if(listLngs[no]==0)return;

/*14:*/
#line 328 "fixedsize.web"


buckets= listBuckets[no];
while(buckets!=nil)
{
ZIBFree(buckets[0]);
saveBucket= buckets;
buckets= (ptr*)buckets[1];
ReturnElem(listOfLists,saveBucket);
}
freeLists[no]= nil;
listLngs[no]= 0;
bucketLngs[no]= 0;

/*:14*/
#line 318 "fixedsize.web"


return;
}

/*:13*//*15:*/
#line 347 "fixedsize.web"


static ptr GetBucket(int lng,int bucketSize)
{
ptr bucket,*pt;
int k;

bucket= (ptr)ZIBAlloc((long)bucketSize*lng);
if(bucket==nil)return nil;
/*16:*/
#line 362 "fixedsize.web"


for(k= 0;k<bucketSize-1;k++)
{
pt= (ptr*)&bucket[k*lng];
*pt= &bucket[(k+1)*lng];
}
pt= (ptr*)&bucket[(bucketSize-1)*lng];
*pt= nil;

/*:16*/
#line 356 "fixedsize.web"

return bucket;
}

/*:15*//*17:*/
#line 377 "fixedsize.web"


ptr GetElem(int no)
{
ptr*elem,**lst;
char sbuf[255];

if((no<0)||(no>maxL))
{
sprintf(sbuf,"GetElem: bad list index %d\n",no);
Error(EFS_BAD_INDEX,sbuf);
return nil;
}

if(listLngs[no]==0)return nil;
if(freeLists[no]==nil)

/*18:*/
#line 405 "fixedsize.web"


{
freeLists[no]= (ptr*)GetBucket(listLngs[no],bucketLngs[no]);
if(freeLists[no]==nil)return nil;
if(no!=listOfLists)
{
lst= (ptr**)GetElem(listOfLists);
if(lst==nil)return false;
lst[0]= freeLists[no];
lst[1]= listBuckets[no];
listBuckets[no]= (ptr*)lst;
}
}

/*:18*/
#line 394 "fixedsize.web"


elem= freeLists[no];
freeLists[no]= (ptr*)freeLists[no][0];
memset((char*)elem,0,listLngs[no]);
return(ptr)elem;
}

/*:17*//*19:*/
#line 424 "fixedsize.web"


ptr ReturnElem(int no,ptr*elem)
{
ptr*buckets;
char*pt,*ptElem= (char*)elem;
int bucketByteLng;

if((no<0)||(no>maxL))return nil;
if(listLngs[no]==0)return nil;

elem[0]= (ptr)freeLists[no];
freeLists[no]= elem;

if(checkMode)
{
memset(ptElem+4,0,listLngs[no]-4);
buckets= listBuckets[no];
bucketByteLng= bucketLngs[no]*listLngs[no];
pt= buckets[0];
while(buckets!=nil)
{
if((pt<=ptElem)&&(ptElem<pt+bucketByteLng))
return nil;
buckets= (ptr*)buckets[1];
pt= buckets[0];
}
printf("ReturnElem:Adress %08x not from list %d (%s)\n",
elem,no,listNames[no]);
elem= nil;
return elem[0];
}

return nil;
}

/*:19*//*20:*/
#line 470 "fixedsize.web"


ptr GetSmallElem(int size)
{
int k,frame;
if(size<=0)return nil;

if(size<MAX_SMALL_SIZE)
{
if(smallLists[size]==0)
{
frame= ((size-1)/8)*8+8;
smallLists[frame]= CreateList(frame,SMALL_BUCKET_SIZE,"small");
if(smallLists[frame]<0)return nil;
for(k= frame-7;k<frame;k++)smallLists[k]= smallLists[frame];
}
return GetElem(smallLists[size]);
}
return(ptr)ZIBAlloc((long)size);
}

/*:20*//*21:*/
#line 494 "fixedsize.web"


void ReturnSmallElem(int size,ptr*elem)
{
if((elem==nil)||(size<=0))return;
if(size<MAX_SMALL_SIZE)
{
if(smallLists[size]>=0)ReturnElem(smallLists[size],elem);
}
else ZIBFree(elem);
return;
}

/*:21*//*22:*/
#line 515 "fixedsize.web"


void InformLists(void(*UserProc)(int,int,int,int,int,char*))
{
int k,noOfBuckets,noOfFreeElements;
ptr*buckets,*elem;

for(k= 0;k<maxL;k++)
{
if(listLngs[k]<0)continue;
noOfBuckets= 0;
noOfFreeElements= 0;
buckets= listBuckets[k];
while(buckets!=nil)
{
noOfBuckets++;buckets= (ptr*)buckets[1];
}
elem= freeLists[k];
while(elem!=nil)
{
noOfFreeElements++;elem= (ptr*)elem[0];
}
(*UserProc)(k,listLngs[k],bucketLngs[k],(k==0)?1:noOfBuckets,
noOfFreeElements,listNames[k]);
}
return;
}

/*:22*//*23:*/
#line 546 "fixedsize.web"


int SetCheckMode(int cm)
{
int oldCm= checkMode;

checkMode= cm;
return oldCm;
}

/*:23*//*24:*/
#line 564 "fixedsize.web"


static long listCount,freeCount,memCount;
static char*globListName;

static int CompString(char*s1,char*s2)
{
char c1,c2;

if((s1==nil)||(s2==nil))return false;
c1= *s1;c2= *s2;
while(c1==c2)
{
if((c1==NUL)&&(c2==NUL))return true;
s1++;s2++;
c1= *s1;c2= *s2;
if(isupper(c1))c1= tolower(c1);
if(isupper(c2))c2= tolower(c2);
}
return false;
}

static void PrintListLine(int k,int size,int bucketLng,int noOfBuckets,
int noOfFreeElements,char*name)
{
char s[256];

if(globListName==nil)
{
sprintf(s,"%2d %4d %6d %6d %8d %s\n",k,size,
noOfBuckets*bucketLng-noOfFreeElements,noOfFreeElements,
size*bucketLng*noOfBuckets,name?name:"-");
ZIBStdOut(s);
listCount++;
memCount+= noOfBuckets*bucketLng-noOfFreeElements;
freeCount+= noOfFreeElements;
return;
}
if(CompString(name,globListName))
{
sprintf(s,"id=%d, size=%d, elems=%d, free=%d, mem=%d, name='%s'\n",k,size,
noOfBuckets*bucketLng-noOfFreeElements,noOfFreeElements,
size*bucketLng*noOfBuckets,name);
ZIBStdOut(s);
listCount++;
memCount+= noOfBuckets*bucketLng-noOfFreeElements;
freeCount+= noOfFreeElements;
return;
}
}

/*:24*//*25:*/
#line 618 "fixedsize.web"



int InfFixed(command*cmd)
{
int index,oldCheckMode;
char*tp;
char s[256];

freeCount= memCount= listCount= 0;
if((cmd->noOfPars)==0)index= -1;
else
{
tp= (cmd->pars)[1];
index= CheckName(&tp,cmd->names,nameClass);
}

switch(index)
{
case-1:
InformLists(PrintListLine);

if((cmd->noOfPars)==0)
sprintf(cmd->results,"%d %d %d",listCount,memCount,freeCount);
else
{
if(listCount==0)
{
sprintf(s,"List '%s' not found\n",globListName);
ZIBStdOut(s);
return false;
}
else sprintf(cmd->results,"%d %d %d",listCount,memCount,freeCount);
}
break;
case 0:
oldCheckMode= SetCheckMode(true);
ZIBStdOut("Check mode on\n");
sprintf(cmd->results,"%s %s",oldCheckMode?"true":"false","true");
break;
case 1:
oldCheckMode= SetCheckMode(false);
ZIBStdOut("Check mode off\n");
sprintf(cmd->results,"%s %s",oldCheckMode?"true":"false","false");
break;
}
return true;
}

/*:25*/
#line 138 "fixedsize.web"


/*:5*/
