/*1:*/
#line 22 "rahmen.web"


/*12:*/
#line 162 "rahmen.web"


#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>

#ifdef unix
#include <sys/times.h>
#include <unistd.h>
#endif

#include <start.h>

#ifdef gethostname
EXTERN_FUNCTION(int gethostname,(char*,int));
#endif

#define MAX_MOD             10
#define ENVP_BLOCK          30
#define MAX_DATE_LNG        20
#define MAX_TIME_LNG        20

struct procQueue
{
t_UserProc proc;
struct procQueue*next;
};

typedef struct procQueue procQueue;

struct localVars
{
char*name;
char*value;
t_UserFunction func;
};

typedef struct localVars localVars;

struct ModInfPool
{
char*name;
localVars**envp;
procQueue*procs;
};

typedef struct ModInfPool ModInfPool;

static char*CheckID(t_ModulID,char*);
static char*CopyString(char*);
static char*ReturnString(char*);
static ModInfPool**pools= nil;
static procQueue*SearchQueueElem(procQueue*,t_UserProc);
static procQueue*NewQueueElem(t_UserProc,procQueue*);
static t_ModulID StoreName(t_ModulID,char*);
static void PrintExpandText(t_ModulID,char*);
static void RetQueueElem(procQueue*,procQueue*);
static void SetDefaults();
static int DelVar(localVars**,char*);
static int AssembleArgs(int,char**,int,int*,char**);

int globArgC= 0;
char**globArgV= nil;
char**globEnvp= nil;
int*globArgReq;

/*:12*/
#line 24 "rahmen.web"

/*13:*/
#line 245 "rahmen.web"


t_ModulID Z_InitModul(char*name)
{
t_ModulID k;
int i;
char*mainName;

if(pools==nil)
{
pools= (ModInfPool**)malloc(MAX_MOD*sizeof(ModInfPool*));
if(pools==nil)
{
fprintf(stderr,"Z_InitModul: kein Speicher fuer 'pools'!\n");
return(d_noModulID);
}
memset((void*)pools,nil,MAX_MOD*sizeof(ModInfPool*));
if(globArgV==nil)
{
mainName= "Programm";
}
else
{
for(i= strlen(globArgV[0])-1;i>=0;i--)
{
if(globArgV[0][i]=='/')break;
}
i++;
mainName= &globArgV[0][i];
}
k= StoreName(d_mainModulID,mainName);
if(k==d_noModulID)return k;
SetDefaults();
}
if(name==nil)return d_mainModulID;
else
for(k= 1;k<MAX_MOD;k++)
{
if(pools[k]==nil)break;
if(strcmp(pools[k]->name,name)==nil)
{
fprintf(stderr,"Z_InitModul: Zum zweiten Mal '%s'\n",name);
return k;
}
}
if(k==MAX_MOD)
{
fprintf(stderr,"Z_InitModul: Mehr als '%d' Module\n",k);
return d_noModulID;
}
return(StoreName(k,name));
}

/*:13*//*14:*/
#line 301 "rahmen.web"


static t_ModulID StoreName(t_ModulID mid,char*name)
{
pools[mid]= (ModInfPool*)malloc(sizeof(ModInfPool));
if(pools[mid]==nil)
{
fprintf(stderr,"StoreName: kein Speicher fuer pools[%d]\n",mid);
return d_noModulID;
}
pools[mid]->name= (char*)malloc((strlen(name)+1)*sizeof(char));
if(pools[mid]->name==nil)
{
fprintf(stderr,"StoreName: kein Speicher fuer pools[%d]->name\n",mid);
return d_noModulID;
}
strcpy(pools[mid]->name,name);
pools[mid]->envp= nil;
pools[mid]->procs= nil;
Z_ModSet(mid,d_StartText,"Start $ModName ($ModVersion) auf $HostName\n");
Z_ModSet(mid,d_EndeText,"Ende $ModName\n");
Z_ModSet(mid,d_ModName,name);
return mid;
}

/*:14*//*15:*/
#line 330 "rahmen.web"


static void SetDefaults()
{
Z_ModSet(d_mainModulID,d_ModVersion,"0.0");
Z_ModSet(d_mainModulID,d_ModeAbout,"Keine Modulinformation vorhanden");
Z_ModSet(d_mainModulID,d_InitFileName,"Z_Rahmenrc");
Z_ModSet(d_mainModulID,d_PathVarName,"PATH");
Z_ModDef(d_mainModulID,d_ActDate,Z_Date);
Z_ModDef(d_mainModulID,d_ActTime,Z_Time);
Z_ModDef(d_mainModulID,d_UsedTime,Z_UsedTime);
Z_ModDef(d_mainModulID,d_HostName,Z_Hostname);
return;
}

/*:15*//*16:*/
#line 357 "rahmen.web"


void Z_Start(t_ModulID mid)
{
char*modulName,*startText;

if((modulName= CheckID(mid,"Z_Start"))==nil)return;
if(!Z_ModGet(mid,d_StartText,&startText))
{
fprintf(stderr,"Z_Start: Fuer Modul '%s' kein Endetext gefunden\n",
modulName);
return;
}
PrintExpandText(mid,startText);
return;
}

/*:16*//*17:*/
#line 379 "rahmen.web"


static char*CheckID(t_ModulID mid,char*progName)
{
if(!pools)Z_InitModul(nil);
if(mid<0||mid>=MAX_MOD||pools[mid]==nil)
{
fprintf(stderr,"%s: ModulID '%d' ungueltig\n",progName,mid);
return nil;
}
if(pools==nil||pools[mid]==nil)return nil;
return pools[mid]->name;
}

/*:17*//*18:*/
#line 397 "rahmen.web"


static void PrintExpandText(t_ModulID mid,char*text)
{
char*startName,*endeName,save,*parWert;
int varEnde= -1;

while(*text)
{
if(*text=='$')
{
text++;
if(*text=='(')
{
text++;if(!*text)break;varEnde= ')';
}
startName= text;
while(isdigit(*text)||isalpha(*text))
text++;
endeName= text;
if(varEnde!=-1)
{
if(*text==varEnde){text++;}
else
{
save= *text;*text= '\0';
fprintf(stderr,
"\nPrintExpandText: Name '%s' nicht korrekt abgeschlossen\n",
startName);*text= save;break;
}
}
save= *endeName;*endeName= '\0';
if(Z_ModGet(mid,startName,&parWert))
while(*parWert)putchar(*parWert++);
*endeName= save;varEnde= -1;
}
else
{
if(*text=='\\'){text++;}
if(!*text){break;}
putchar(*text++);
}
}
}

/*:18*//*19:*/
#line 451 "rahmen.web"


void Z_End(t_ModulID mid,int status)
{
char*modulName,*endeText;
procQueue*q,*save;
int i,k;

if((modulName= CheckID(mid,"Z_End"))==nil)exit(status);
if(pools&&pools[mid])
{
q= pools[mid]->procs;
while(q)
{
q->proc(status);q= q->next;
}
}
if(!Z_ModGet(mid,d_EndeText,&endeText))
{
fprintf(stderr,"Z_End: Fuer Modul '%s' kein EndeText gefunden\n",
modulName);
return;
}
if(*endeText)PrintExpandText(mid,endeText);

q= pools[mid]->procs;
while(q){save= q->next;free((char*)q);q= save;}
for(k= 0;pools[mid]->envp[k]!=nil&&k<ENVP_BLOCK;k++)
{
if(pools[mid]->envp[k]->name)free(pools[mid]->envp[k]->name);
if(pools[mid]->envp[k]->value)free(pools[mid]->envp[k]->value);
free((char*)pools[mid]->envp[k]);
}
free((char*)pools[mid]->envp);
free(pools[mid]->name);
free((char*)pools[mid]);
pools[mid]= nil;

if(mid!=d_mainModulID)return;
for(i= 0;i<MAX_MOD&&pools[i]!=nil;i++)Z_End(i,status);
free((char*)pools);
exit(status);
}

/*:19*//*20:*/
#line 504 "rahmen.web"


int Z_DoAtEnd(t_ModulID mid,t_UserProc p,t_ProcPos pos,t_UserProc ref)
{
char*name= CheckID(mid,"Z_DoAtEnd");
procQueue*pQueue,*last,*next;

if(name==nil)return false;
if(p==nil&&ref==nil)
{
if(pos==procBefore||pos==procAfter)return true;
RetQueueElem(pools[mid]->procs,nil);
pools[mid]->procs= nil;return true;
}
if(ref==nil)
{
switch(pos)
{
case procBefore:
pools[mid]->procs= NewQueueElem(p,pools[mid]->procs);
return true;
case procSubst:
RetQueueElem(pools[mid]->procs,nil);
pools[mid]->procs= NewQueueElem(p,nil);
return true;
case procAfter:
pQueue= pools[mid]->procs;
if(pQueue==nil)
{
pools[mid]->procs= NewQueueElem(p,nil);return true;
}
while(pQueue->next)pQueue= pQueue->next;
pQueue->next= NewQueueElem(p,nil);
return true;
}
}
if(p==nil)
{
last= SearchQueueElem(pools[mid]->procs,ref);
if(last==nil)
{
fprintf(stderr,"SearchQueueElem: Referenz nicht gefunden\n");
return false;
}
switch(pos)
{
case procBefore:
if((last->proc)==ref)return true;
next= last->next;
RetQueueElem(pools[mid]->procs,next);
pools[mid]->procs= next;
return true;
case procSubst:
if((last->proc)==ref)
{
pools[mid]->procs= last->next;
RetQueueElem(last,last->next);
return true;
}
last->next= (last->next)->next;
RetQueueElem(last->next,(last->next)->next);
return true;
case procAfter:
next= ((last->proc)==ref)?last->next:(last->next)->next;
RetQueueElem(next->next,nil);next->next= nil;
return true;
}
}
last= SearchQueueElem(pools[mid]->procs,ref);
if(last==nil)
{
fprintf(stderr,"SearchQueueElem: Referenz nicht gefunden\n");
return false;
}
switch(pos)
{
case procBefore:
if((last->proc)==ref)
{
pools[mid]->procs= NewQueueElem(p,last);return true;
}
last->next= NewQueueElem(p,last->next);return true;
case procSubst:
if((last->proc)==ref)
{
pools[mid]->procs= NewQueueElem(p,last->next);
RetQueueElem(last,last->next);
return true;
}
next= last->next;
last->next= NewQueueElem(p,next->next);
RetQueueElem(next,next->next);
return true;
case procAfter:
if((last->proc)!=ref)last= last->next;
last->next= NewQueueElem(p,last->next);
return true;
}
return true;
}

/*:20*//*21:*/
#line 610 "rahmen.web"


static procQueue*SearchQueueElem(procQueue*start,t_UserProc ref)
{
procQueue*last= start,*pQueue= start;

if(start==nil)return nil;
if((pQueue->proc)==ref)return last;
pQueue= start->next;
while(pQueue)
{
if((pQueue->proc)==ref)return last;
last= pQueue->next;pQueue= pQueue->next;
}
return nil;
}

/*:21*//*22:*/
#line 631 "rahmen.web"


static void RetQueueElem(procQueue*anfang,procQueue*ende)
{
procQueue*pQueue= anfang,*next;

while(pQueue!=ende){next= pQueue->next;free((char*)pQueue);pQueue= next;}
return;
}

/*:22*//*23:*/
#line 645 "rahmen.web"


static procQueue*NewQueueElem(t_UserProc p,procQueue*next)
{
procQueue*rc;

rc= (procQueue*)malloc(sizeof(procQueue));
if(!rc)
{
fprintf(stderr,"New_QueueElem: Kein Speicher fuer ein neues Element\n");
return nil;
}
rc->proc= p;rc->next= next;return rc;
}

/*:23*/
#line 25 "rahmen.web"

/*24:*/
#line 668 "rahmen.web"


void Z_Unix(int argc,char**argv,char**envp)
{
int k;
globArgC= argc;
globArgV= argv;
globEnvp= envp;
globArgReq= (int*)malloc(argc*sizeof(int));
globArgReq[0]= true;for(k= 1;k<argc;k++)globArgReq[k]= false;

return;
}

/*:24*//*25:*/
#line 685 "rahmen.web"


int Z_ModSet(t_ModulID mid,char*par,char*val)
{
int k,lng,lngval;
localVars**envp;
char*modulName;

if((modulName= CheckID(mid,"Z_ModSet"))==nil)return false;
if(pools[mid]->envp==nil)
{
pools[mid]->envp= 
(localVars**)malloc(ENVP_BLOCK*sizeof(localVars*));
if(pools[mid]->envp==nil)
{
fprintf(stderr,"Z_ModSet: kein Speicher fuer pools[%d]->envp\n",
mid);
return false;
}
for(k= 0;k<ENVP_BLOCK;k++)pools[mid]->envp[k]= nil;
}
envp= pools[mid]->envp;
lng= strlen(par);
k= DelVar(envp,par);
if(k==ENVP_BLOCK)
{
fprintf(stderr,"Z_ModSet: Modul '%s' hat mehr als %d Environment-Variablen\n",
modulName,k);
return false;
}
if(val==nil)return true;
lngval= strlen(val);
envp[k]= (localVars*)malloc(sizeof(localVars));
envp[k]->name= (char*)malloc((lng+1)*sizeof(char));
envp[k]->value= (char*)malloc((lngval+1)*sizeof(char));
envp[k]->func= nil;
if(envp[k]==nil||envp[k]->name==nil||envp[k]->value==nil)
{
fprintf(stderr,"Z_ModSet: kein Speicher fuer 'pools[%d]->envp[%d]'!\n",
mid,k);
return false;
}
strcpy(envp[k]->name,par);strcpy(envp[k]->value,val);
return true;
}

/*:25*//*26:*/
#line 736 "rahmen.web"


static int DelVar(localVars**envp,char*par)
{
int k,i;
for(k= 0;k<ENVP_BLOCK;k++)
{
if(envp[k]==nil)break;
if(envp[k]->name&&(strcmp(par,envp[k]->name)==0))
{
if(envp[k]->name)free(envp[k]->name);
if(envp[k]->value)free(envp[k]->value);
if(envp[k])free((char*)envp[k]);
for(i= k+1;i<ENVP_BLOCK;i++)
if(envp[i]==nil)break;
i--;envp[k]= envp[i];envp[i]= nil;k= i;break;
}
}
return k;
}

/*:26*//*27:*/
#line 763 "rahmen.web"


int Z_ModDef(t_ModulID mid,char*par,t_UserFunction f)
{
int k,lng;
localVars**envp;
char*modulName;

if((modulName= CheckID(mid,"Z_ModSet"))==nil)return false;
if(pools[mid]->envp==nil)
{
pools[mid]->envp= 
(localVars**)malloc(ENVP_BLOCK*sizeof(localVars*));
if(pools[mid]->envp==nil)
{
fprintf(stderr,"Z_ModSet: kein Speicher fuer pools[%d]->envp\n",
mid);
return false;
}
for(k= 0;k<ENVP_BLOCK;k++)pools[mid]->envp[k]= nil;
}
envp= pools[mid]->envp;
lng= strlen(par);
k= DelVar(envp,par);
if(k==ENVP_BLOCK)
{
fprintf(stderr,"Z_ModDef: Modul '%s' hat mehr als %d Environment-Variablen\n",
modulName,k);
return false;
}
if(f==nil)return true;
envp[k]= (localVars*)malloc(sizeof(localVars));
envp[k]->name= (char*)malloc((lng+1)*sizeof(char));
envp[k]->value= nil;
envp[k]->func= f;
if(envp[k]==nil||envp[k]->name==nil)
{
fprintf(stderr,"Z_ModDef: kein Speicher fuer 'pools[%d]->envp[%d]'!\n",
mid,k);
return false;
}
strcpy(envp[k]->name,par);

return true;
}

/*:27*//*28:*/
#line 812 "rahmen.web"


char*Z_Date()
{
char*actDate= (char*)malloc(11*sizeof(char));
time_t adp= time(nil);
struct tm*tm;

tm= localtime(&adp);
if(tm==nil)
{
fprintf(stderr,"Z_Date: Keine Zeitangabe moeglich\n");
return nil;
}
sprintf(actDate,"%02d.%02d.19%02d",tm->tm_mday,(tm->tm_mon)+1,tm->tm_year);
return actDate;
}

/*:28*//*29:*/
#line 833 "rahmen.web"


char*Z_Time()
{
char*actTime= (char*)malloc(9*sizeof(char));
time_t adp= time(nil);
struct tm*tm;

tm= localtime(&adp);
if(tm==nil)
{
fprintf(stderr,"Z_Time: Keine Zeitangabe moeglich\n");
return nil;
}
sprintf(actTime,"%02d:%02d:%02d",tm->tm_hour,tm->tm_min,tm->tm_sec);
return actTime;
}

/*:29*//*30:*/
#line 854 "rahmen.web"


char*Z_UsedTime()
{
char*usedTime;
#ifdef unix
float tim,clocks_per_second;
struct tms now;

usedTime= (char*)malloc(14*sizeof(char));
#ifdef CLOCKS_PER_SEC
clocks_per_second= CLOCKS_PER_SEC;
#else
#   ifdef CLK_TCK
clocks_per_second= CLK_TCK;
#   else
clocks_per_second= sysconf(_SC_CLK_TCK);
#   endif
#endif

times(&now);
tim= (now.tms_utime)/clocks_per_second;
sprintf(usedTime,"%13.3f",tim);
return usedTime;
#else
usedTime= CopyString("0 (Zeitroutine unbekannt)");
return usedTime;
#endif
}

/*:30*//*31:*/
#line 887 "rahmen.web"


char*Z_Hostname()
{
#ifdef gethostname
char name[256];

if((gethostname(name,256))==0)
return(CopyString(name));
#endif
return(CopyString("(Rechner unbekannt)"));
}

/*:31*//*32:*/
#line 905 "rahmen.web"


int Z_ModGet(t_ModulID mid,char*par,char**val)
{
char*modulName;
char**locArgv= (char**)malloc(globArgC*sizeof(char*));
static char*noNameBuffer,*noReqBuffer;
localVars**envp;
int k,kk,lng,rc;

if(par==d_argNoName)
{
rc= AssembleArgs(globArgC-1,&globArgV[1],'-',&(globArgReq[1]),&noNameBuffer);
*val= noNameBuffer;return rc;
}
if(par==d_argNotReq)
{
kk= 0;
for(k= 0;k<globArgC;k++)
{
if(globArgReq[k])continue;
locArgv[kk++]= globArgV[k];
}
AssembleArgs(kk,locArgv,-1,nil,&noReqBuffer);
*val= noReqBuffer;return true;
}
for(k= 1;k<globArgC;k++)
{
if(globArgV[k][0]!='-')continue;
if(strcmp(par,&globArgV[k][1])==0)
{
*val= nil;globArgReq[k]= true;
rc= AssembleArgs(globArgC-k-1,&globArgV[k+1],'-',&(globArgReq[k+1]),val);
if(rc)return true;
}
}
lng= strlen(par);
k= -1;
while(globEnvp[++k]!=nil)
{
if(globEnvp[k][lng]!='=')continue;
if(strncmp(par,globEnvp[k],lng)==0)
{*val= globEnvp[k]+lng+1;return true;}
}
if((modulName= CheckID(mid,"Z_ModGet"))==nil)
{
*val= nil;return false;
}

envp= pools[mid]->envp;
if(envp==nil){*val= nil;return false;}
for(k= 0;k<ENVP_BLOCK&&envp[k]!=nil;k++)
{
if(strcmp(par,envp[k]->name)==0)
{
if(envp[k]->value){*val= envp[k]->value;return true;}
*val= (envp[k]->func)();return true;
}
}

*val= nil;return false;
}

/*:32*//*33:*/
#line 973 "rahmen.web"


static int AssembleArgs(int n,char**args,int delimiter,int*reqs,char
**buffer)
{
int k,len= 0,i;

for(k= 0;k<n;k++)
{
if(delimiter>=0)if(*args[k]==delimiter)break;
len+= strlen(args[k])+1;
if(reqs)reqs[k]= true;
}
if(len==0){*buffer= nil;return false;}
if(*buffer)free(*buffer);
*buffer= (char*)malloc((len+1)*sizeof(char));

if(*buffer==nil)

{

fprintf(stderr,"AssembleArgs: kein Speicher fuer 'buffer'!\n");

return false;

}
(*buffer)[0]= '\0';

for(i= 0;i<k;i++)

{

strcat(*buffer,args[i]);

strcat(*buffer," ");

}

(*buffer)[len-1]= '\0';

return true;

}


/*:33*/
#line 26 "rahmen.web"

/*34:*/
#line 1028 "rahmen.web"


char*Z_FRead(t_ModulID id,const char*fileName,long*fileLength)
{
int returnCode;
int bufferLength;
char*buffer,errorBuffer[256];
static FILE*fileDescr;

fileDescr= Z_FOpen(id,fileName,"r");
if(fileDescr==nil)return nil;
returnCode= fseek(fileDescr,0L,2);
if(returnCode!=0)
{
perror("Z_FRead");
fclose(fileDescr);
return nil;
}
bufferLength= (int)ftell(fileDescr);
if(bufferLength<0)
{
perror("Z_FRead");
fclose(fileDescr);
return nil;
}
rewind(fileDescr);
buffer= (char*)malloc(bufferLength+1);
if(buffer==nil)
{
sprintf(errorBuffer,
"Z_FRead: Not enough memory to store %ld bytesof '%s'\n",
bufferLength,fileName);
puts(errorBuffer);
fclose(fileDescr);
return nil;
}
bufferLength= fread(buffer,1,bufferLength,fileDescr);
buffer[bufferLength]= '\0';
*fileLength= bufferLength;
Z_FClose(&fileDescr);

return buffer;
}

/*:34*//*35:*/
#line 1075 "rahmen.web"


void Z_FClose(FILE**f){fclose(*f);*f= nil;return;}

/*:35*//*36:*/
#line 1083 "rahmen.web"


void Z_ReturnFileBuf(char**buf){free(*buf);*buf= nil;return;}

/*:36*//*37:*/
#line 1096 "rahmen.web"


FILE*Z_FOpen(t_ModulID mid,const char*filename,const char*mode)
{
int lng= strlen(filename),lngDir;
char*PathVarName,*dir,name[BUFSIZ],*path,*pathCopy;
FILE*f= nil;

if(CheckID(mid,"Z_FOpen")==nil)return nil;
if(!Z_ModGet(mid,d_PathVarName,&PathVarName))
{
return fopen(filename,mode);
}
if(!Z_ModGet(mid,PathVarName,&path))
{
return fopen(filename,mode);
}
pathCopy= CopyString(path);
dir= strtok(pathCopy,":");
while(dir)
{
lngDir= strlen(dir);
if((lngDir+lng+2)>BUFSIZ)
{
fprintf(stderr,"Z_FOpen: Puffer fuer Pfadnamen zu kurz\n");
return nil;
}
strcpy(name,dir);name[lngDir]= '/';strcpy(&name[lngDir+1],filename);
f= fopen(name,mode);
if(f!=nil)break;
dir= strtok(nil,":");
}
pathCopy= ReturnString(pathCopy);
return f;
}

/*:37*//*38:*/
#line 1135 "rahmen.web"


static char*CopyString(char*string)
{
char*rc= (char*)malloc((strlen(string)+1)*sizeof(char));
if(rc)strcpy(rc,string);return rc;
}

/*:38*//*39:*/
#line 1145 "rahmen.web"


static char*ReturnString(char*string){free(string);return nil;}

/*:39*/
#line 27 "rahmen.web"


/*:1*/
