#   File:       solvelib.make
#   Target:     solvelib
#   Sources:    problem.c shape.c localass.c stdproblem.c compadapt.c
#               solsetup.c solcmd.c cg.c bicgstab.c ssor.c hb.c bpx.c cholfull.c cholenv.c
#   Created:    Samstag, 12. Februar 1992 12:43:50 Uhr

OBJECTS = problem.c.o shape.c.o localass.c.o stdproblem.c.o 
          solsetup.c.o solcmd.c.o cg.c.o ssor.c.o hb.c.o bpx.c.o 
		  cholfull.c.o  cholenv.c.o bicgstab.c.o compadapt.c.o 
		  ellesti.c.o cgs.c.o gmres.c.o
COPTS = -mc68020 -mc68881 -i {KaskInterface} -sym on -model far # -trace on
CC = C

solvelib  solvelib.make {OBJECTS}
	Lib -o {kasklibraries}solvelib.a {OBJECTS}
problem.c.o  problem.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}problem.h
	 {CC} problem.c {COPTS} -s problem
shape.c.o  shape.c {KaskInterface}zibutil.h {KaskInterface}triang2.h 
			 {KaskInterface}problem.h {KaskInterface}assemble.h
	 {CC} shape.c {COPTS} -s shape
localass.c.o  localass.c {KaskInterface}zibutil.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}assemble.h
	 {CC} localass.c {COPTS} -s localass
stdproblem.c.o  stdproblem.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}params.h {KaskInterface}problem.h
	 {CC} stdproblem.c {COPTS} -s stdproblem -w
#tomproblem.c.o  tomproblem.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
#			 {KaskInterface}params.h {KaskInterface}problem.h
#	 {CC} tomproblem.c {COPTS} -s tomproblem -w
solsetup.c.o  solsetup.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}appevents.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}assemble.h {KaskInterface}solve.h
	 {CC} solsetup.c {COPTS} -s solsetup
solcmd.c.o  solcmd.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}appevents.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}assemble.h {KaskInterface}solve.h
	 {CC} solcmd.c {COPTS} -s solcmd
cg.c.o  cg.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h 
			 {KaskInterface}problem.h {KaskInterface}solve.h
	 {CC} cg.c {COPTS} -s cg
cgs.c.o  cgs.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h 
			 {KaskInterface}problem.h {KaskInterface}solve.h
	 {CC} cgs.c {COPTS} -s cgs
bicgstab.c.o  bicgstab.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h 
			 {KaskInterface}problem.h {KaskInterface}solve.h
	 {CC} bicgstab.c {COPTS} -s bicgstab
gmres.c.o  gmres.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h 
			 {KaskInterface}problem.h {KaskInterface}solve.h
	 {CC} gmres.c {COPTS} -s gmres
ssor.c.o  ssor.c {KaskInterface}zibutil.h {KaskInterface}access.h 
             {KaskInterface}params.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h {KaskInterface}assemble.h
	 {CC} ssor.c {COPTS} -s ssor
hb.c.o  hb.c {KaskInterface}zibutil.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h
	 {CC} hb.c {COPTS} -s hb
bpx.c.o  bpx.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}params.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h
	 {CC} bpx.c {COPTS} -s bpx
cholfull.c.o  cholfull.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h
	 {CC} cholfull.c {COPTS} -s cholfull
cholenv.c.o  cholenv.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h
	 {CC} cholenv.c {COPTS} -s cholenv
compadapt.c  compadapt.web
	 ctangle compadapt dummy
	 cweave compadapt dummy
	 move -y compadapt.h {KaskInterface}compadapt.h
compadapt.c.o  compadapt.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}appevents.h {KaskInterface}commands.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h
	 {CC} compadapt.c {COPTS} -s compadapt
ellesti.c.o  ellesti.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {KaskInterface}triang2.h 
			 {KaskInterface}nodes.h {KaskInterface}problem.h 
			 {KaskInterface}solve.h {KaskInterface}compadapt.h
	 {CC} ellesti.c {COPTS} -s ellesti
